<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: src/core/CL/cl_kernels/gemm.cl Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.xhtml"><span>File&#160;List</span></a></li>
      <li><a href="globals.xhtml"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('gemm_8cl_source.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">gemm.cl</div>  </div>
</div><!--header-->
<div class="contents">
<a href="gemm_8cl.xhtml">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2017 ARM Limited.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-License-Identifier: MIT</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a copy</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * of this software and associated documentation files (the &quot;Software&quot;), to</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * deal in the Software without restriction, including without limitation the</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * sell copies of the Software, and to permit persons to whom the Software is</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * furnished to do so, subject to the following conditions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * The above copyright notice and this permission notice shall be included in all</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * copies or substantial portions of the Software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * SOFTWARE.</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="helpers_8h.xhtml">helpers.h</a>&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div><div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="gemm_8cl.xhtml#a21d7061f36aec78824e368f2ef1cafc1">   41</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="gemm_8cl.xhtml#a21d7061f36aec78824e368f2ef1cafc1">gemm_transpose1x4_f32</a>(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;                                    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;{</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    uint x = get_global_id(0);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    uint y = get_global_id(1);</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="comment">/* Compute address for Matrix B - source */</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="comment">/* Compute address for Matrix B transposed - destination. X and Y are swapped */</span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    uint dst_addr_in_bytes = y * 16 + ((x * dst_stride_y + dst_offset_first_element_in_bytes));</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    float4 b0 = vload4(0, (__global <span class="keywordtype">float</span> *)src.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    vstore4(b0, 0, (__global <span class="keywordtype">float</span> *)(dst_ptr + dst_addr_in_bytes));</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;}</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;</div><div class="line"><a name="l00073"></a><span class="lineno"><a class="line" href="gemm_8cl.xhtml#a11d87ecaf1388b4f57404e062265b374">   73</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="gemm_8cl.xhtml#a11d87ecaf1388b4f57404e062265b374">gemm_transpose1x8_f16</a>(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;                                    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;{</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    uint x = get_global_id(0);</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    uint y = get_global_id(1);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <span class="comment">/* Compute address for Matrix B - source */</span></div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="comment">/* Compute address for Matrix B transposed - destination. X and Y are swapped */</span></div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    uint dst_addr_in_bytes = y * 16 + ((x * dst_stride_y + dst_offset_first_element_in_bytes));</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    half8 b0 = vload8(0, (__global half *)src.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    vstore8(b0, 0, (__global half *)(dst_ptr + dst_addr_in_bytes));</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;}</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;</div><div class="line"><a name="l00105"></a><span class="lineno"><a class="line" href="gemm_8cl.xhtml#a675879eb72964ddbd5f71155da3b0cc3">  105</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="gemm_8cl.xhtml#a675879eb72964ddbd5f71155da3b0cc3">gemm_transpose1x16_u8</a>(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;                                    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;{</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    uint x = get_global_id(0);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    uint y = get_global_id(1);</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <span class="comment">/* Compute address for Matrix B - source */</span></div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="comment">/* Compute address for Matrix B transposed - destination. X and Y are swapped */</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    uint dst_addr_in_bytes = y * 16 + ((x * dst_stride_y + dst_offset_first_element_in_bytes));</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    uchar16 b0 = vload16(0, (__global uchar *)src.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    vstore16(b0, 0, (__global uchar *)(dst_ptr + dst_addr_in_bytes));</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;}</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;</div><div class="line"><a name="l00137"></a><span class="lineno"><a class="line" href="gemm_8cl.xhtml#acd423b6f992354e7c00137b20d687281">  137</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="gemm_8cl.xhtml#acd423b6f992354e7c00137b20d687281">gemm_interleave4x4_f32</a>(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;                                     <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;{</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <span class="comment">/* Compute source and destination addresses */</span></div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <span class="comment">/* Load values from Matrix A */</span></div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    float4 a0 = vload4(0, (__global <span class="keywordtype">float</span> *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 0)));</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    float4 a1 = vload4(0, (__global <span class="keywordtype">float</span> *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 1)));</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    float4 a2 = vload4(0, (__global <span class="keywordtype">float</span> *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 2)));</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    float4 a3 = vload4(0, (__global <span class="keywordtype">float</span> *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 3)));</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    float4 val0 = (float4)(a0.s0, a1.s0, a2.s0, a3.s0);</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    vstore4(val0, 0, ((__global <span class="keywordtype">float</span> *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 0);</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    val0 = (float4)(a0.s1, a1.s1, a2.s1, a3.s1);</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    vstore4(val0, 0, ((__global <span class="keywordtype">float</span> *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 4);</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    val0 = (float4)(a0.s2, a1.s2, a2.s2, a3.s2);</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    vstore4(val0, 0, ((__global <span class="keywordtype">float</span> *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 8);</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    val0 = (float4)(a0.s3, a1.s3, a2.s3, a3.s3);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    vstore4(val0, 0, ((__global <span class="keywordtype">float</span> *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 12);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;}</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno"><a class="line" href="gemm_8cl.xhtml#ae333c12d780666b2591f7c8e9faaf5a9">  178</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="gemm_8cl.xhtml#ae333c12d780666b2591f7c8e9faaf5a9">gemm_interleave4x4_f16</a>(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;                                     <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;{</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    <span class="comment">/* Compute source and destination addresses */</span></div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    <span class="comment">/* Load values from Matrix A */</span></div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    half8 a0 = vload8(0, (__global half *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 0)));</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    half8 a1 = vload8(0, (__global half *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 1)));</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    half8 a2 = vload8(0, (__global half *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 2)));</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    half8 a3 = vload8(0, (__global half *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 3)));</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    half8 val0 = (half8)((half4)(a0.s0, a1.s0, a2.s0, a3.s0), (half4)(a0.s1, a1.s1, a2.s1, a3.s1));</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    vstore8(val0, 0, ((__global half *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 0);</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    val0 = (half8)((half4)(a0.s2, a1.s2, a2.s2, a3.s2), (half4)(a0.s3, a1.s3, a2.s3, a3.s3));</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    vstore8(val0, 0, ((__global half *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 8);</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    val0 = (half8)((half4)(a0.s4, a1.s4, a2.s4, a3.s4), (half4)(a0.s5, a1.s5, a2.s5, a3.s5));</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    vstore8(val0, 0, ((__global half *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 16);</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    val0 = (half8)((half4)(a0.s6, a1.s6, a2.s6, a3.s6), (half4)(a0.s7, a1.s7, a2.s7, a3.s7));</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    vstore8(val0, 0, ((__global half *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 24);</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;}</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div><div class="line"><a name="l00219"></a><span class="lineno"><a class="line" href="gemm_8cl.xhtml#a830ba1cc0ad3c8cffa4a14424b2d0411">  219</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="gemm_8cl.xhtml#a830ba1cc0ad3c8cffa4a14424b2d0411">gemm_interleave4x4_u8</a>(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;                                    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;{</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <span class="comment">/* Compute source and destination addresses */</span></div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    <span class="comment">/* Load values from Matrix A */</span></div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    uchar16 a0 = vload16(0, (__global uchar *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 0)));</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    uchar16 a1 = vload16(0, (__global uchar *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 1)));</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    uchar16 a2 = vload16(0, (__global uchar *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 2)));</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    uchar16 a3 = vload16(0, (__global uchar *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 3)));</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    uchar16 val0 = (uchar16)((uchar4)(a0.s0, a1.s0, a2.s0, a3.s0), (uchar4)(a0.s1, a1.s1, a2.s1, a3.s1),</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;                             (uchar4)(a0.s2, a1.s2, a2.s2, a3.s2), (uchar4)(a0.s3, a1.s3, a2.s3, a3.s3));</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    vstore16(val0, 0, ((__global uchar *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 0);</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    val0 = (uchar16)((uchar4)(a0.s4, a1.s4, a2.s4, a3.s4), (uchar4)(a0.s5, a1.s5, a2.s5, a3.s5),</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;                     (uchar4)(a0.s6, a1.s6, a2.s6, a3.s6), (uchar4)(a0.s7, a1.s7, a2.s7, a3.s7));</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    vstore16(val0, 0, ((__global uchar *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 16);</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    val0 = (uchar16)((uchar4)(a0.s8, a1.s8, a2.s8, a3.s8), (uchar4)(a0.s9, a1.s9, a2.s9, a3.s9),</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;                     (uchar4)(a0.sA, a1.sA, a2.sA, a3.sA), (uchar4)(a0.sB, a1.sB, a2.sB, a3.sB));</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    vstore16(val0, 0, ((__global uchar *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 32);</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    val0 = (uchar16)((uchar4)(a0.sC, a1.sC, a2.sC, a3.sC), (uchar4)(a0.sD, a1.sD, a2.sD, a3.sD),</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;                     (uchar4)(a0.sE, a1.sE, a2.sE, a3.sE), (uchar4)(a0.sF, a1.sF, a2.sF, a3.sF));</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    vstore16(val0, 0, ((__global uchar *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>) + 48);</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;}</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;</div><div class="line"><a name="l00262"></a><span class="lineno"><a class="line" href="gemm_8cl.xhtml#a7c619984bc9c31f5f6c19ecc88b56581">  262</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="gemm_8cl.xhtml#a7c619984bc9c31f5f6c19ecc88b56581">gemm_accumulate_biases_f32</a>(</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(accum),</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    <a class="code" href="helpers_8h.xhtml#a40a6eb9f2a7712f08d6bb8ff6c9e6ca7">VECTOR_DECLARATION</a>(biases))</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;{</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a>  accum  = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(accum);</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    <a class="code" href="struct_vector.xhtml">Vector</a> biases = <a class="code" href="helpers_8h.xhtml#a527bfdf5eeb306f1cf01c4a8e29f38e0">CONVERT_TO_VECTOR_STRUCT</a>(biases);</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    float4 accum_value  = vload4(0, (__global <span class="keywordtype">float</span> *)accum.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    float4 biases_value = vload4(0, (__global <span class="keywordtype">float</span> *)biases.<a class="code" href="struct_vector.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    accum_value         = biases_value + accum_value;</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <span class="comment">// Store result in the accummulate buffer</span></div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    vstore4(accum_value, 0, (__global <span class="keywordtype">float</span> *)accum.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;}</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;</div><div class="line"><a name="l00290"></a><span class="lineno"><a class="line" href="gemm_8cl.xhtml#a76295c333dfa3c9bb20975579dce87e8">  290</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="gemm_8cl.xhtml#a76295c333dfa3c9bb20975579dce87e8">gemm_accumulate_biases_f16</a>(</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(accum),</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    <a class="code" href="helpers_8h.xhtml#a40a6eb9f2a7712f08d6bb8ff6c9e6ca7">VECTOR_DECLARATION</a>(biases))</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;{</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a>  accum  = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(accum);</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <a class="code" href="struct_vector.xhtml">Vector</a> biases = <a class="code" href="helpers_8h.xhtml#a527bfdf5eeb306f1cf01c4a8e29f38e0">CONVERT_TO_VECTOR_STRUCT</a>(biases);</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    half8 accum_value  = vload8(0, (__global half *)accum.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    half8 biases_value = vload8(0, (__global half *)biases.<a class="code" href="struct_vector.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    accum_value        = biases_value + accum_value;</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    <span class="comment">// Store result in the accummulate buffer</span></div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;    vstore8(accum_value, 0, (__global half *)accum.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;}</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="preprocessor">#if(defined WIDTH_MATRIX_B)</span></div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;</div><div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;__kernel <span class="keywordtype">void</span> gemm_mm_u8(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src0),</div><div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;                         <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src1),</div><div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;                         <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst),</div><div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;                         <span class="keywordtype">int</span> a_offset,</div><div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;                         <span class="keywordtype">int</span> b_offset,</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;                         <span class="keywordtype">int</span> c_offset,</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;                         <span class="keywordtype">int</span> c_mult_int,</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;                         <span class="keywordtype">int</span> shift)</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;{</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;    <span class="comment">/* src_addr.s0 = address of matrix A */</span></div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    <span class="comment">/* src_addr.s1 = address of matrix B */</span></div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;    <span class="comment">/* Compute address for matrix A and B */</span></div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;    int2 src_addr = (int2)(get_global_id(1), get_global_id(0)) * (int2)((src0_stride_y),</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;                                                                        (src1_stride_y));</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    <span class="comment">/* Add offset_first_element_in_bytes */</span></div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    src_addr = src_addr + ((int2)(src0_offset_first_element_in_bytes, src1_offset_first_element_in_bytes));</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;    <span class="comment">/* Compute end row address for matrix B */</span></div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    <span class="keywordtype">int</span> end_row_mtx_b = src_addr.s1 + WIDTH_MATRIX_B;</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    <span class="comment">/* Reset accumulators */</span></div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;    int16 c00 = 0.0f;</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    int16 c10 = 0.0f;</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;    int16 c20 = 0.0f;</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;    int16 c30 = 0.0f;</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;</div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    <span class="keywordflow">for</span>(; src_addr.s1 &lt;= (end_row_mtx_b - 8); src_addr += (int2)(8, 32))</div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;    {</div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;        <span class="comment">/* Load values from matrix A (interleaved) and matrix B (transposed) */</span></div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;        int8 a0  = (int8)a_offset + convert_int8(vload8(0, ((__global uchar *)src0_ptr) + src_addr.s0));</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;        int16 b0 = (int16)b_offset + convert_int16(vload16(0, ((__global uchar *)src1_ptr) + src_addr.s1));</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;        c00 += (int16)a0.s0 * b0;</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;        c10 += (int16)a0.s1 * b0;</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;        c20 += (int16)a0.s2 * b0;</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;        c30 += (int16)a0.s3 * b0;</div><div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;</div><div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;        int16 b1 = (int16)b_offset + convert_int16(vload16(0, ((__global uchar *)src1_ptr) + src_addr.s1 + 16));</div><div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;</div><div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;        c00 += (int16)a0.s4 * b1;</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;        c10 += (int16)a0.s5 * b1;</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;        c20 += (int16)a0.s6 * b1;</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;        c30 += (int16)a0.s7 * b1;</div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;    }</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;    <span class="keywordflow">for</span>(; src_addr.s1 &lt; end_row_mtx_b; src_addr += (int2)(4, 16))</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;    {</div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;        <span class="comment">/* Load values from matrix A (interleaved) and matrix B (transposed) */</span></div><div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;        int4 a0  = (int4)a_offset + convert_int4(vload4(0, ((__global uchar *)src0_ptr) + src_addr.s0));</div><div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;        int16 b0 = (int16)b_offset + convert_int16(vload16(0, ((__global uchar *)src1_ptr) + src_addr.s1));</div><div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;        c00 += (int16)a0.s0 * b0;</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;        c10 += (int16)a0.s1 * b0;</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;        c20 += (int16)a0.s2 * b0;</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;        c30 += (int16)a0.s3 * b0;</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;    }</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;    <span class="comment">/* Compute destination address */</span></div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;    <span class="comment">/* Multiply by the weight of matrix product */</span></div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;    c00 = (((int16)c_offset + c00) * (int16)c_mult_int) &gt;&gt; shift;</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;    c10 = (((int16)c_offset + c10) * (int16)c_mult_int) &gt;&gt; shift;</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;    c20 = (((int16)c_offset + c20) * (int16)c_mult_int) &gt;&gt; shift;</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;    c30 = (((int16)c_offset + c30) * (int16)c_mult_int) &gt;&gt; shift;</div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;</div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;    <span class="comment">/* Store 4x16 block */</span></div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;    vstore16(convert_uchar16_sat(c00), 0, (__global uchar *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 0)));</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;    vstore16(convert_uchar16_sat(c10), 0, (__global uchar *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 1)));</div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;    vstore16(convert_uchar16_sat(c20), 0, (__global uchar *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 2)));</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;    vstore16(convert_uchar16_sat(c30), 0, (__global uchar *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 3)));</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;}</div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;</div><div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;<span class="preprocessor">#if(defined WIDTH_MATRIX_B &amp;&amp; defined ALPHA)</span></div><div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;__kernel <span class="keywordtype">void</span> gemm_mm_f32(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src0),</div><div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;                          <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src1),</div><div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;                          <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;{</div><div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;    <span class="comment">/* src_addr.s0 = address of matrix A */</span></div><div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;    <span class="comment">/* src_addr.s1 = address of matrix B */</span></div><div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;</div><div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;    <span class="comment">/* Compute address for matrix A and B */</span></div><div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;    int2 src_addr = (int2)(get_global_id(1), get_global_id(0)) * (int2)((src0_stride_y),</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;                                                                        (src1_stride_y));</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;    <span class="comment">/* Add offset_first_element_in_bytes */</span></div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;    src_addr = src_addr + ((int2)(src0_offset_first_element_in_bytes, src1_offset_first_element_in_bytes));</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;    <span class="comment">/* Divide by 4 in order to get the src_addr in unit of float */</span></div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;    src_addr = src_addr &gt;&gt; 2;</div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;    <span class="comment">/* Compute end row address for matrix B */</span></div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;    <span class="keywordtype">int</span> end_row_mtx_b = src_addr.s1 + WIDTH_MATRIX_B;</div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;    <span class="comment">/* Reset accumulators */</span></div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;    float4 c00 = 0.0f;</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;    float4 c10 = 0.0f;</div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;    float4 c20 = 0.0f;</div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;    float4 c30 = 0.0f;</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;    <span class="keywordflow">for</span>(; src_addr.s1 &lt;= (end_row_mtx_b - 8); src_addr += (int2)(8, 8))</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;    {</div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;        <span class="comment">/* Load values from matrix A (interleaved) and matrix B (transposed) */</span></div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;        float4 a0 = vload4(0, ((__global <span class="keywordtype">float</span> *)src0_ptr) + src_addr.s0);</div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;        float4 b0 = vload4(0, ((__global <span class="keywordtype">float</span> *)src1_ptr) + src_addr.s1);</div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;        c00 += (float4)a0.s0 * b0;</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;        c10 += (float4)a0.s1 * b0;</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;        c20 += (float4)a0.s2 * b0;</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;        c30 += (float4)a0.s3 * b0;</div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;        <span class="comment">/* Load values from matrix A (interleaved) and matrix B (transposed) */</span></div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;        a0 = vload4(0, ((__global <span class="keywordtype">float</span> *)src0_ptr) + src_addr.s0 + 4);</div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;        b0 = vload4(0, ((__global <span class="keywordtype">float</span> *)src1_ptr) + src_addr.s1 + 4);</div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;        c00 += (float4)a0.s0 * b0;</div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;        c10 += (float4)a0.s1 * b0;</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;        c20 += (float4)a0.s2 * b0;</div><div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;        c30 += (float4)a0.s3 * b0;</div><div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;    }</div><div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;</div><div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;    <span class="keywordflow">for</span>(; src_addr.s1 &lt; end_row_mtx_b; src_addr += (int2)(4, 4))</div><div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;    {</div><div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;        <span class="comment">/* Load values from matrix A (interleaved) and matrix B (transposed) */</span></div><div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;        float4 a0 = vload4(0, ((__global <span class="keywordtype">float</span> *)src0_ptr) + src_addr.s0);</div><div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;        float4 b0 = vload4(0, ((__global <span class="keywordtype">float</span> *)src1_ptr) + src_addr.s1);</div><div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;</div><div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;        c00 += (float4)a0.s0 * b0;</div><div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;        c10 += (float4)a0.s1 * b0;</div><div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;        c20 += (float4)a0.s2 * b0;</div><div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;        c30 += (float4)a0.s3 * b0;</div><div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;    }</div><div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;</div><div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;    <span class="comment">/* Compute destination address */</span></div><div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;</div><div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;    <span class="comment">/* Multiply by the weight of matrix product */</span></div><div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;    c00 = c00 * (float4)ALPHA;</div><div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;    c10 = c10 * (float4)ALPHA;</div><div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;    c20 = c20 * (float4)ALPHA;</div><div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;    c30 = c30 * (float4)ALPHA;</div><div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;</div><div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;    <span class="comment">/* Store 4x4 block */</span></div><div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;    vstore4(c00, 0, (__global <span class="keywordtype">float</span> *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 0)));</div><div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;    vstore4(c10, 0, (__global <span class="keywordtype">float</span> *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 1)));</div><div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;    vstore4(c20, 0, (__global <span class="keywordtype">float</span> *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 2)));</div><div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;    vstore4(c30, 0, (__global <span class="keywordtype">float</span> *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 3)));</div><div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;}</div><div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;</div><div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;__kernel <span class="keywordtype">void</span> gemm_mm_f16(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src0),</div><div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160;                          <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src1),</div><div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;                          <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;{</div><div class="line"><a name="l00539"></a><span class="lineno">  539</span>&#160;    <span class="comment">/* src_addr.s0 = address of matrix A */</span></div><div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;    <span class="comment">/* src_addr.s1 = address of matrix B */</span></div><div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;</div><div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;    <span class="comment">/* Compute address for matrix A and B */</span></div><div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;    int2 src_addr = (int2)(get_global_id(1), get_global_id(0)) * (int2)((src0_stride_y),</div><div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160;                                                                        (src1_stride_y));</div><div class="line"><a name="l00545"></a><span class="lineno">  545</span>&#160;</div><div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;    <span class="comment">/* Add offset_first_element_in_bytes */</span></div><div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;    src_addr = src_addr + ((int2)(src0_offset_first_element_in_bytes, src1_offset_first_element_in_bytes));</div><div class="line"><a name="l00548"></a><span class="lineno">  548</span>&#160;</div><div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;    <span class="comment">/* Divide by 2 in order to get the src_addr in unit of half */</span></div><div class="line"><a name="l00550"></a><span class="lineno">  550</span>&#160;    src_addr = src_addr &gt;&gt; 1;</div><div class="line"><a name="l00551"></a><span class="lineno">  551</span>&#160;</div><div class="line"><a name="l00552"></a><span class="lineno">  552</span>&#160;    <span class="comment">/* Compute end row address for matrix B */</span></div><div class="line"><a name="l00553"></a><span class="lineno">  553</span>&#160;    <span class="keywordtype">int</span> end_row_mtx_b = src_addr.s1 + WIDTH_MATRIX_B;</div><div class="line"><a name="l00554"></a><span class="lineno">  554</span>&#160;</div><div class="line"><a name="l00555"></a><span class="lineno">  555</span>&#160;    <span class="comment">/* Reset accumulators */</span></div><div class="line"><a name="l00556"></a><span class="lineno">  556</span>&#160;    half8 c00 = 0.0f;</div><div class="line"><a name="l00557"></a><span class="lineno">  557</span>&#160;    half8 c10 = 0.0f;</div><div class="line"><a name="l00558"></a><span class="lineno">  558</span>&#160;    half8 c20 = 0.0f;</div><div class="line"><a name="l00559"></a><span class="lineno">  559</span>&#160;    half8 c30 = 0.0f;</div><div class="line"><a name="l00560"></a><span class="lineno">  560</span>&#160;</div><div class="line"><a name="l00561"></a><span class="lineno">  561</span>&#160;    <span class="keywordflow">for</span>(; src_addr.s1 &lt;= (end_row_mtx_b - 8); src_addr += (int2)(8, 16))</div><div class="line"><a name="l00562"></a><span class="lineno">  562</span>&#160;    {</div><div class="line"><a name="l00563"></a><span class="lineno">  563</span>&#160;        <span class="comment">/* Load values from matrix A (interleaved) and matrix B (transposed) */</span></div><div class="line"><a name="l00564"></a><span class="lineno">  564</span>&#160;        half4 a0 = vload4(0, ((__global half *)src0_ptr) + src_addr.s0);</div><div class="line"><a name="l00565"></a><span class="lineno">  565</span>&#160;        half8 b0 = vload8(0, ((__global half *)src1_ptr) + src_addr.s1);</div><div class="line"><a name="l00566"></a><span class="lineno">  566</span>&#160;</div><div class="line"><a name="l00567"></a><span class="lineno">  567</span>&#160;        c00 += (half8)a0.s0 * b0;</div><div class="line"><a name="l00568"></a><span class="lineno">  568</span>&#160;        c10 += (half8)a0.s1 * b0;</div><div class="line"><a name="l00569"></a><span class="lineno">  569</span>&#160;        c20 += (half8)a0.s2 * b0;</div><div class="line"><a name="l00570"></a><span class="lineno">  570</span>&#160;        c30 += (half8)a0.s3 * b0;</div><div class="line"><a name="l00571"></a><span class="lineno">  571</span>&#160;</div><div class="line"><a name="l00572"></a><span class="lineno">  572</span>&#160;        <span class="comment">/* Load values from matrix A (interleaved) and matrix B (transposed) */</span></div><div class="line"><a name="l00573"></a><span class="lineno">  573</span>&#160;        a0 = vload4(0, ((__global half *)src0_ptr) + src_addr.s0 + 4);</div><div class="line"><a name="l00574"></a><span class="lineno">  574</span>&#160;        b0 = vload8(0, ((__global half *)src1_ptr) + src_addr.s1 + 8);</div><div class="line"><a name="l00575"></a><span class="lineno">  575</span>&#160;</div><div class="line"><a name="l00576"></a><span class="lineno">  576</span>&#160;        c00 += (half8)a0.s0 * b0;</div><div class="line"><a name="l00577"></a><span class="lineno">  577</span>&#160;        c10 += (half8)a0.s1 * b0;</div><div class="line"><a name="l00578"></a><span class="lineno">  578</span>&#160;        c20 += (half8)a0.s2 * b0;</div><div class="line"><a name="l00579"></a><span class="lineno">  579</span>&#160;        c30 += (half8)a0.s3 * b0;</div><div class="line"><a name="l00580"></a><span class="lineno">  580</span>&#160;    }</div><div class="line"><a name="l00581"></a><span class="lineno">  581</span>&#160;</div><div class="line"><a name="l00582"></a><span class="lineno">  582</span>&#160;    <span class="keywordflow">for</span>(; src_addr.s1 &lt; end_row_mtx_b; src_addr += (int2)(4, 8))</div><div class="line"><a name="l00583"></a><span class="lineno">  583</span>&#160;    {</div><div class="line"><a name="l00584"></a><span class="lineno">  584</span>&#160;        <span class="comment">/* Load values from matrix A (interleaved) and matrix B (transposed) */</span></div><div class="line"><a name="l00585"></a><span class="lineno">  585</span>&#160;        half4 a0 = vload4(0, ((__global half *)src0_ptr) + src_addr.s0);</div><div class="line"><a name="l00586"></a><span class="lineno">  586</span>&#160;        half8 b0 = vload8(0, ((__global half *)src1_ptr) + src_addr.s1);</div><div class="line"><a name="l00587"></a><span class="lineno">  587</span>&#160;</div><div class="line"><a name="l00588"></a><span class="lineno">  588</span>&#160;        c00 += (half8)a0.s0 * b0;</div><div class="line"><a name="l00589"></a><span class="lineno">  589</span>&#160;        c10 += (half8)a0.s1 * b0;</div><div class="line"><a name="l00590"></a><span class="lineno">  590</span>&#160;        c20 += (half8)a0.s2 * b0;</div><div class="line"><a name="l00591"></a><span class="lineno">  591</span>&#160;        c30 += (half8)a0.s3 * b0;</div><div class="line"><a name="l00592"></a><span class="lineno">  592</span>&#160;    }</div><div class="line"><a name="l00593"></a><span class="lineno">  593</span>&#160;</div><div class="line"><a name="l00594"></a><span class="lineno">  594</span>&#160;    <span class="comment">/* Compute destination address */</span></div><div class="line"><a name="l00595"></a><span class="lineno">  595</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00596"></a><span class="lineno">  596</span>&#160;</div><div class="line"><a name="l00597"></a><span class="lineno">  597</span>&#160;    <span class="comment">/* Multiply by the weight of matrix product */</span></div><div class="line"><a name="l00598"></a><span class="lineno">  598</span>&#160;    c00 = c00 * (half8)ALPHA;</div><div class="line"><a name="l00599"></a><span class="lineno">  599</span>&#160;    c10 = c10 * (half8)ALPHA;</div><div class="line"><a name="l00600"></a><span class="lineno">  600</span>&#160;    c20 = c20 * (half8)ALPHA;</div><div class="line"><a name="l00601"></a><span class="lineno">  601</span>&#160;    c30 = c30 * (half8)ALPHA;</div><div class="line"><a name="l00602"></a><span class="lineno">  602</span>&#160;</div><div class="line"><a name="l00603"></a><span class="lineno">  603</span>&#160;    <span class="comment">/* Store 4x8 block */</span></div><div class="line"><a name="l00604"></a><span class="lineno">  604</span>&#160;    vstore8(c00, 0, (__global half *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 0)));</div><div class="line"><a name="l00605"></a><span class="lineno">  605</span>&#160;    vstore8(c10, 0, (__global half *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 1)));</div><div class="line"><a name="l00606"></a><span class="lineno">  606</span>&#160;    vstore8(c20, 0, (__global half *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 2)));</div><div class="line"><a name="l00607"></a><span class="lineno">  607</span>&#160;    vstore8(c30, 0, (__global half *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 3)));</div><div class="line"><a name="l00608"></a><span class="lineno">  608</span>&#160;}</div><div class="line"><a name="l00609"></a><span class="lineno">  609</span>&#160;</div><div class="line"><a name="l00635"></a><span class="lineno">  635</span>&#160;<span class="preprocessor">#if(defined WIDTH_VECTOR_A)</span></div><div class="line"><a name="l00636"></a><span class="lineno">  636</span>&#160;__kernel <span class="keywordtype">void</span> gemm_vm_f32(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src0),</div><div class="line"><a name="l00637"></a><span class="lineno">  637</span>&#160;                          <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src1),</div><div class="line"><a name="l00638"></a><span class="lineno">  638</span>&#160;                          <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00639"></a><span class="lineno">  639</span>&#160;{</div><div class="line"><a name="l00640"></a><span class="lineno">  640</span>&#160;    <span class="keywordtype">int</span> idx = get_global_id(0) * 4;</div><div class="line"><a name="l00641"></a><span class="lineno">  641</span>&#160;</div><div class="line"><a name="l00642"></a><span class="lineno">  642</span>&#160;    <span class="comment">/* Compute the address for the vector A and matrix B */</span></div><div class="line"><a name="l00643"></a><span class="lineno">  643</span>&#160;    int2 src_addr = ((int2)(src0_offset_first_element_in_bytes, src1_offset_first_element_in_bytes));</div><div class="line"><a name="l00644"></a><span class="lineno">  644</span>&#160;    src_addr.s1 += idx * <span class="keyword">sizeof</span>(float);</div><div class="line"><a name="l00645"></a><span class="lineno">  645</span>&#160;</div><div class="line"><a name="l00646"></a><span class="lineno">  646</span>&#160;    <span class="keywordtype">int</span> end_row_vec_a = src_addr.s0 + (WIDTH_VECTOR_A * <span class="keyword">sizeof</span>(float));</div><div class="line"><a name="l00647"></a><span class="lineno">  647</span>&#160;</div><div class="line"><a name="l00648"></a><span class="lineno">  648</span>&#160;    float4 acc = 0.0f;</div><div class="line"><a name="l00649"></a><span class="lineno">  649</span>&#160;</div><div class="line"><a name="l00650"></a><span class="lineno">  650</span>&#160;    <span class="keywordflow">for</span>(; src_addr.s0 &lt;= (end_row_vec_a - 2 * <span class="keyword">sizeof</span>(float)); src_addr += (int2)(2 * <span class="keyword">sizeof</span>(<span class="keywordtype">float</span>), 2 * src1_stride_y))</div><div class="line"><a name="l00651"></a><span class="lineno">  651</span>&#160;    {</div><div class="line"><a name="l00652"></a><span class="lineno">  652</span>&#160;        float2 a0 = vload2(0, (__global <span class="keywordtype">float</span> *)(src0_ptr + src_addr.s0));</div><div class="line"><a name="l00653"></a><span class="lineno">  653</span>&#160;        float4 b0 = vload4(0, (__global <span class="keywordtype">float</span> *)(src1_ptr + src_addr.s1));</div><div class="line"><a name="l00654"></a><span class="lineno">  654</span>&#160;        float4 b1 = vload4(0, (__global <span class="keywordtype">float</span> *)(src1_ptr + src_addr.s1 + src1_stride_y));</div><div class="line"><a name="l00655"></a><span class="lineno">  655</span>&#160;</div><div class="line"><a name="l00656"></a><span class="lineno">  656</span>&#160;        acc += b0 * (float4)a0.s0;</div><div class="line"><a name="l00657"></a><span class="lineno">  657</span>&#160;        acc += b1 * (float4)a0.s1;</div><div class="line"><a name="l00658"></a><span class="lineno">  658</span>&#160;    }</div><div class="line"><a name="l00659"></a><span class="lineno">  659</span>&#160;</div><div class="line"><a name="l00660"></a><span class="lineno">  660</span>&#160;    <span class="keywordflow">for</span>(; src_addr.s0 &lt; end_row_vec_a; src_addr += (int2)(<span class="keyword">sizeof</span>(<span class="keywordtype">float</span>), src1_stride_y))</div><div class="line"><a name="l00661"></a><span class="lineno">  661</span>&#160;    {</div><div class="line"><a name="l00662"></a><span class="lineno">  662</span>&#160;        <span class="keywordtype">float</span>  a0 = *((__global <span class="keywordtype">float</span> *)(src0_ptr + src_addr.s0));</div><div class="line"><a name="l00663"></a><span class="lineno">  663</span>&#160;        float4 b0 = vload4(0, (__global <span class="keywordtype">float</span> *)(src1_ptr + src_addr.s1));</div><div class="line"><a name="l00664"></a><span class="lineno">  664</span>&#160;</div><div class="line"><a name="l00665"></a><span class="lineno">  665</span>&#160;        acc += b0 * (float4)a0;</div><div class="line"><a name="l00666"></a><span class="lineno">  666</span>&#160;    }</div><div class="line"><a name="l00667"></a><span class="lineno">  667</span>&#160;</div><div class="line"><a name="l00668"></a><span class="lineno">  668</span>&#160;    <span class="comment">/* Compute destination address */</span></div><div class="line"><a name="l00669"></a><span class="lineno">  669</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00670"></a><span class="lineno">  670</span>&#160;</div><div class="line"><a name="l00671"></a><span class="lineno">  671</span>&#160;    <span class="comment">/* Multiply by the weight of vector-matrix product */</span></div><div class="line"><a name="l00672"></a><span class="lineno">  672</span>&#160;    acc = acc * (float4)ALPHA;</div><div class="line"><a name="l00673"></a><span class="lineno">  673</span>&#160;</div><div class="line"><a name="l00674"></a><span class="lineno">  674</span>&#160;    vstore4(acc, 0, (__global <span class="keywordtype">float</span> *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 0)));</div><div class="line"><a name="l00675"></a><span class="lineno">  675</span>&#160;}</div><div class="line"><a name="l00676"></a><span class="lineno">  676</span>&#160;</div><div class="line"><a name="l00702"></a><span class="lineno">  702</span>&#160;__kernel <span class="keywordtype">void</span> gemm_vm_f16(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src0),</div><div class="line"><a name="l00703"></a><span class="lineno">  703</span>&#160;                          <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src1),</div><div class="line"><a name="l00704"></a><span class="lineno">  704</span>&#160;                          <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00705"></a><span class="lineno">  705</span>&#160;{</div><div class="line"><a name="l00706"></a><span class="lineno">  706</span>&#160;    <span class="keywordtype">int</span> idx = get_global_id(0) * 8;</div><div class="line"><a name="l00707"></a><span class="lineno">  707</span>&#160;</div><div class="line"><a name="l00708"></a><span class="lineno">  708</span>&#160;    <span class="comment">/* Compute the address for the vector A and matrix B */</span></div><div class="line"><a name="l00709"></a><span class="lineno">  709</span>&#160;    int2 src_addr = ((int2)(src0_offset_first_element_in_bytes, src1_offset_first_element_in_bytes));</div><div class="line"><a name="l00710"></a><span class="lineno">  710</span>&#160;    src_addr.s1 += idx * <span class="keyword">sizeof</span>(half);</div><div class="line"><a name="l00711"></a><span class="lineno">  711</span>&#160;</div><div class="line"><a name="l00712"></a><span class="lineno">  712</span>&#160;    <span class="keywordtype">int</span> end_row_vec_a = src_addr.s0 + (WIDTH_VECTOR_A * <span class="keyword">sizeof</span>(half));</div><div class="line"><a name="l00713"></a><span class="lineno">  713</span>&#160;</div><div class="line"><a name="l00714"></a><span class="lineno">  714</span>&#160;    half8 acc = 0.0f;</div><div class="line"><a name="l00715"></a><span class="lineno">  715</span>&#160;</div><div class="line"><a name="l00716"></a><span class="lineno">  716</span>&#160;    <span class="keywordflow">for</span>(; src_addr.s0 &lt;= (end_row_vec_a - 4 * <span class="keyword">sizeof</span>(half)); src_addr += (int2)(4 * <span class="keyword">sizeof</span>(half), 4 * src1_stride_y))</div><div class="line"><a name="l00717"></a><span class="lineno">  717</span>&#160;    {</div><div class="line"><a name="l00718"></a><span class="lineno">  718</span>&#160;        half4 a0 = vload4(0, (__global half *)(src0_ptr + src_addr.s0));</div><div class="line"><a name="l00719"></a><span class="lineno">  719</span>&#160;        half8 b0 = vload8(0, (__global half *)(src1_ptr + src_addr.s1 + 0 * src1_stride_y));</div><div class="line"><a name="l00720"></a><span class="lineno">  720</span>&#160;        half8 b1 = vload8(0, (__global half *)(src1_ptr + src_addr.s1 + 1 * src1_stride_y));</div><div class="line"><a name="l00721"></a><span class="lineno">  721</span>&#160;        half8 b2 = vload8(0, (__global half *)(src1_ptr + src_addr.s1 + 2 * src1_stride_y));</div><div class="line"><a name="l00722"></a><span class="lineno">  722</span>&#160;        half8 b3 = vload8(0, (__global half *)(src1_ptr + src_addr.s1 + 3 * src1_stride_y));</div><div class="line"><a name="l00723"></a><span class="lineno">  723</span>&#160;</div><div class="line"><a name="l00724"></a><span class="lineno">  724</span>&#160;        acc += b0 * (half8)a0.s0;</div><div class="line"><a name="l00725"></a><span class="lineno">  725</span>&#160;        acc += b1 * (half8)a0.s1;</div><div class="line"><a name="l00726"></a><span class="lineno">  726</span>&#160;        acc += b2 * (half8)a0.s2;</div><div class="line"><a name="l00727"></a><span class="lineno">  727</span>&#160;        acc += b3 * (half8)a0.s3;</div><div class="line"><a name="l00728"></a><span class="lineno">  728</span>&#160;    }</div><div class="line"><a name="l00729"></a><span class="lineno">  729</span>&#160;</div><div class="line"><a name="l00730"></a><span class="lineno">  730</span>&#160;    <span class="keywordflow">for</span>(; src_addr.s0 &lt; end_row_vec_a; src_addr += (int2)(<span class="keyword">sizeof</span>(half), src1_stride_y))</div><div class="line"><a name="l00731"></a><span class="lineno">  731</span>&#160;    {</div><div class="line"><a name="l00732"></a><span class="lineno">  732</span>&#160;        half a0  = *((__global half *)(src0_ptr + src_addr.s0));</div><div class="line"><a name="l00733"></a><span class="lineno">  733</span>&#160;        half8 b0 = vload8(0, (__global half *)(src1_ptr + src_addr.s1));</div><div class="line"><a name="l00734"></a><span class="lineno">  734</span>&#160;</div><div class="line"><a name="l00735"></a><span class="lineno">  735</span>&#160;        acc += b0 * (half8)a0;</div><div class="line"><a name="l00736"></a><span class="lineno">  736</span>&#160;    }</div><div class="line"><a name="l00737"></a><span class="lineno">  737</span>&#160;</div><div class="line"><a name="l00738"></a><span class="lineno">  738</span>&#160;    <span class="comment">/* Compute destination address */</span></div><div class="line"><a name="l00739"></a><span class="lineno">  739</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00740"></a><span class="lineno">  740</span>&#160;</div><div class="line"><a name="l00741"></a><span class="lineno">  741</span>&#160;    <span class="comment">/* Multiply by the weight of vector-matrix product */</span></div><div class="line"><a name="l00742"></a><span class="lineno">  742</span>&#160;    acc = acc * (half8)ALPHA;</div><div class="line"><a name="l00743"></a><span class="lineno">  743</span>&#160;</div><div class="line"><a name="l00744"></a><span class="lineno">  744</span>&#160;    vstore8(acc, 0, (__global half *)(<a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;dst, 0, 0)));</div><div class="line"><a name="l00745"></a><span class="lineno">  745</span>&#160;}</div><div class="line"><a name="l00746"></a><span class="lineno">  746</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* (defined WIDTH_VECTOR_A) */</span><span class="preprocessor"></span></div><div class="line"><a name="l00747"></a><span class="lineno">  747</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* (defined WIDTH_MATRIX_B &amp;&amp; defined ALPHA) */</span><span class="preprocessor"></span></div><div class="line"><a name="l00748"></a><span class="lineno">  748</span>&#160;</div><div class="line"><a name="l00766"></a><span class="lineno">  766</span>&#160;<span class="preprocessor">#if(defined BETA)</span></div><div class="line"><a name="l00767"></a><span class="lineno">  767</span>&#160;__kernel <span class="keywordtype">void</span> gemm_ma_f32(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00768"></a><span class="lineno">  768</span>&#160;                          <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00769"></a><span class="lineno">  769</span>&#160;{</div><div class="line"><a name="l00770"></a><span class="lineno">  770</span>&#160;    <span class="comment">/* Compute source and destination addresses */</span></div><div class="line"><a name="l00771"></a><span class="lineno">  771</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00772"></a><span class="lineno">  772</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00773"></a><span class="lineno">  773</span>&#160;</div><div class="line"><a name="l00774"></a><span class="lineno">  774</span>&#160;    <span class="comment">/* Load values from A x B */</span></div><div class="line"><a name="l00775"></a><span class="lineno">  775</span>&#160;    float4 alpha_ab = vload4(0, (__global <span class="keywordtype">float</span> *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00776"></a><span class="lineno">  776</span>&#160;</div><div class="line"><a name="l00777"></a><span class="lineno">  777</span>&#160;    <span class="comment">/* Load values from Matrix C */</span></div><div class="line"><a name="l00778"></a><span class="lineno">  778</span>&#160;    float4 c = vload4(0, (__global <span class="keywordtype">float</span> *)src.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00779"></a><span class="lineno">  779</span>&#160;</div><div class="line"><a name="l00780"></a><span class="lineno">  780</span>&#160;    <span class="comment">/* Computes alpha * axb + beta * c */</span></div><div class="line"><a name="l00781"></a><span class="lineno">  781</span>&#160;    float4 out = alpha_ab + (float4)BETA * c;</div><div class="line"><a name="l00782"></a><span class="lineno">  782</span>&#160;</div><div class="line"><a name="l00783"></a><span class="lineno">  783</span>&#160;    <span class="comment">/* Store final result in axb matrix */</span></div><div class="line"><a name="l00784"></a><span class="lineno">  784</span>&#160;    vstore4(out, 0, (__global <span class="keywordtype">float</span> *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00785"></a><span class="lineno">  785</span>&#160;}</div><div class="line"><a name="l00786"></a><span class="lineno">  786</span>&#160;</div><div class="line"><a name="l00802"></a><span class="lineno">  802</span>&#160;__kernel <span class="keywordtype">void</span> gemm_ma_f16(<a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00803"></a><span class="lineno">  803</span>&#160;                          <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00804"></a><span class="lineno">  804</span>&#160;{</div><div class="line"><a name="l00805"></a><span class="lineno">  805</span>&#160;    <span class="comment">/* Compute source and destination addresses */</span></div><div class="line"><a name="l00806"></a><span class="lineno">  806</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00807"></a><span class="lineno">  807</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00808"></a><span class="lineno">  808</span>&#160;</div><div class="line"><a name="l00809"></a><span class="lineno">  809</span>&#160;    <span class="comment">/* Load values from A x B */</span></div><div class="line"><a name="l00810"></a><span class="lineno">  810</span>&#160;    half8 alpha_ab = vload8(0, (__global half *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00811"></a><span class="lineno">  811</span>&#160;</div><div class="line"><a name="l00812"></a><span class="lineno">  812</span>&#160;    <span class="comment">/* Load values from Matrix C */</span></div><div class="line"><a name="l00813"></a><span class="lineno">  813</span>&#160;    half8 c = vload8(0, (__global half *)src.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00814"></a><span class="lineno">  814</span>&#160;</div><div class="line"><a name="l00815"></a><span class="lineno">  815</span>&#160;    <span class="comment">/* Computes alpha * axb + beta * c */</span></div><div class="line"><a name="l00816"></a><span class="lineno">  816</span>&#160;    half8 out = alpha_ab + (half8)BETA * c;</div><div class="line"><a name="l00817"></a><span class="lineno">  817</span>&#160;</div><div class="line"><a name="l00818"></a><span class="lineno">  818</span>&#160;    <span class="comment">/* Store final result in axb matrix */</span></div><div class="line"><a name="l00819"></a><span class="lineno">  819</span>&#160;    vstore8(out, 0, (__global half *)dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00820"></a><span class="lineno">  820</span>&#160;}</div><div class="line"><a name="l00821"></a><span class="lineno">  821</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* (defined BETA) */</span><span class="preprocessor"></span></div><div class="ttc" id="struct_vector_xhtml"><div class="ttname"><a href="struct_vector.xhtml">Vector</a></div><div class="ttdoc">Structure to hold Vector information. </div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00087">helpers.h:87</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a527bfdf5eeb306f1cf01c4a8e29f38e0"><div class="ttname"><a href="helpers_8h.xhtml#a527bfdf5eeb306f1cf01c4a8e29f38e0">CONVERT_TO_VECTOR_STRUCT</a></div><div class="ttdeci">#define CONVERT_TO_VECTOR_STRUCT(name)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00067">helpers.h:67</a></div></div>
<div class="ttc" id="gemm_8cl_xhtml_a76295c333dfa3c9bb20975579dce87e8"><div class="ttname"><a href="gemm_8cl.xhtml#a76295c333dfa3c9bb20975579dce87e8">gemm_accumulate_biases_f16</a></div><div class="ttdeci">__kernel void gemm_accumulate_biases_f16(__global uchar *accum_ptr, uint accum_stride_x, uint accum_step_x, uint accum_stride_y, uint accum_step_y, uint accum_offset_first_element_in_bytes, __global uchar *biases_ptr, uint biases_stride_x, uint biases_step_x, uint biases_offset_first_element_in_bytes)</div><div class="ttdoc">This kernel accumulates each row with the biases vector. </div><div class="ttdef"><b>Definition:</b> <a href="gemm_8cl_source.xhtml#l00290">gemm.cl:290</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a22f42fcf2077d951271df83b55c1a71a"><div class="ttname"><a href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a></div><div class="ttdeci">#define IMAGE_DECLARATION(name)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00049">helpers.h:49</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a009469e4d9b8fce3b6d5e97d2077827d"><div class="ttname"><a href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a></div><div class="ttdeci">__global uchar * offset(const Image *img, int x, int y)</div><div class="ttdoc">Get the pointer position of a Image. </div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00201">helpers.h:201</a></div></div>
<div class="ttc" id="gemm_8cl_xhtml_a830ba1cc0ad3c8cffa4a14424b2d0411"><div class="ttname"><a href="gemm_8cl.xhtml#a830ba1cc0ad3c8cffa4a14424b2d0411">gemm_interleave4x4_u8</a></div><div class="ttdeci">__kernel void gemm_interleave4x4_u8(__global uchar *src_ptr, uint src_stride_x, uint src_step_x, uint src_stride_y, uint src_step_y, uint src_offset_first_element_in_bytes, __global uchar *dst_ptr, uint dst_stride_x, uint dst_step_x, uint dst_stride_y, uint dst_step_y, uint dst_offset_first_element_in_bytes)</div><div class="ttdoc">This OpenCL kernel reshapes the input matrix transposing each 4x4 block and interleaving the values...</div><div class="ttdef"><b>Definition:</b> <a href="gemm_8cl_source.xhtml#l00219">gemm.cl:219</a></div></div>
<div class="ttc" id="helpers_8h_xhtml"><div class="ttname"><a href="helpers_8h.xhtml">helpers.h</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_aebe814363556c244be043b13e7969197"><div class="ttname"><a href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a></div><div class="ttdeci">#define CONVERT_TO_IMAGE_STRUCT(name)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00073">helpers.h:73</a></div></div>
<div class="ttc" id="gemm_8cl_xhtml_ae333c12d780666b2591f7c8e9faaf5a9"><div class="ttname"><a href="gemm_8cl.xhtml#ae333c12d780666b2591f7c8e9faaf5a9">gemm_interleave4x4_f16</a></div><div class="ttdeci">__kernel void gemm_interleave4x4_f16(__global uchar *src_ptr, uint src_stride_x, uint src_step_x, uint src_stride_y, uint src_step_y, uint src_offset_first_element_in_bytes, __global uchar *dst_ptr, uint dst_stride_x, uint dst_step_x, uint dst_stride_y, uint dst_step_y, uint dst_offset_first_element_in_bytes)</div><div class="ttdoc">This OpenCL kernel reshapes the input matrix transposing each 4x4 block and interleaving the values...</div><div class="ttdef"><b>Definition:</b> <a href="gemm_8cl_source.xhtml#l00178">gemm.cl:178</a></div></div>
<div class="ttc" id="gemm_8cl_xhtml_acd423b6f992354e7c00137b20d687281"><div class="ttname"><a href="gemm_8cl.xhtml#acd423b6f992354e7c00137b20d687281">gemm_interleave4x4_f32</a></div><div class="ttdeci">__kernel void gemm_interleave4x4_f32(__global uchar *src_ptr, uint src_stride_x, uint src_step_x, uint src_stride_y, uint src_step_y, uint src_offset_first_element_in_bytes, __global uchar *dst_ptr, uint dst_stride_x, uint dst_step_x, uint dst_stride_y, uint dst_step_y, uint dst_offset_first_element_in_bytes)</div><div class="ttdoc">This OpenCL kernel reshapes the input matrix transposing each 4x4 block and interleaving the values...</div><div class="ttdef"><b>Definition:</b> <a href="gemm_8cl_source.xhtml#l00137">gemm.cl:137</a></div></div>
<div class="ttc" id="struct_vector_xhtml_acf52c23cbd7424606c10a606524e3e32"><div class="ttname"><a href="struct_vector.xhtml#acf52c23cbd7424606c10a606524e3e32">Vector::ptr</a></div><div class="ttdeci">__global uchar * ptr</div><div class="ttdoc">Pointer to the starting postion of the buffer. </div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00089">helpers.h:89</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a40a6eb9f2a7712f08d6bb8ff6c9e6ca7"><div class="ttname"><a href="helpers_8h.xhtml#a40a6eb9f2a7712f08d6bb8ff6c9e6ca7">VECTOR_DECLARATION</a></div><div class="ttdeci">#define VECTOR_DECLARATION(name)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00043">helpers.h:43</a></div></div>
<div class="ttc" id="struct_image_xhtml"><div class="ttname"><a href="struct_image.xhtml">Image</a></div><div class="ttdoc">Structure to hold Image information. </div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00095">helpers.h:95</a></div></div>
<div class="ttc" id="gemm_8cl_xhtml_a11d87ecaf1388b4f57404e062265b374"><div class="ttname"><a href="gemm_8cl.xhtml#a11d87ecaf1388b4f57404e062265b374">gemm_transpose1x8_f16</a></div><div class="ttdeci">__kernel void gemm_transpose1x8_f16(__global uchar *src_ptr, uint src_stride_x, uint src_step_x, uint src_stride_y, uint src_step_y, uint src_offset_first_element_in_bytes, __global uchar *dst_ptr, uint dst_stride_x, uint dst_step_x, uint dst_stride_y, uint dst_step_y, uint dst_offset_first_element_in_bytes)</div><div class="ttdoc">This OpenCL kernel computes the &quot;vector&quot; 1x8 transposition of input matrix. </div><div class="ttdef"><b>Definition:</b> <a href="gemm_8cl_source.xhtml#l00073">gemm.cl:73</a></div></div>
<div class="ttc" id="struct_image_xhtml_acf52c23cbd7424606c10a606524e3e32"><div class="ttname"><a href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">Image::ptr</a></div><div class="ttdeci">__global uchar * ptr</div><div class="ttdoc">Pointer to the starting postion of the buffer. </div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00097">helpers.h:97</a></div></div>
<div class="ttc" id="gemm_8cl_xhtml_a21d7061f36aec78824e368f2ef1cafc1"><div class="ttname"><a href="gemm_8cl.xhtml#a21d7061f36aec78824e368f2ef1cafc1">gemm_transpose1x4_f32</a></div><div class="ttdeci">__kernel void gemm_transpose1x4_f32(__global uchar *src_ptr, uint src_stride_x, uint src_step_x, uint src_stride_y, uint src_step_y, uint src_offset_first_element_in_bytes, __global uchar *dst_ptr, uint dst_stride_x, uint dst_step_x, uint dst_stride_y, uint dst_step_y, uint dst_offset_first_element_in_bytes)</div><div class="ttdoc">This OpenCL kernel computes the &quot;vector&quot; 1x4 transposition of input matrix. </div><div class="ttdef"><b>Definition:</b> <a href="gemm_8cl_source.xhtml#l00041">gemm.cl:41</a></div></div>
<div class="ttc" id="gemm_8cl_xhtml_a7c619984bc9c31f5f6c19ecc88b56581"><div class="ttname"><a href="gemm_8cl.xhtml#a7c619984bc9c31f5f6c19ecc88b56581">gemm_accumulate_biases_f32</a></div><div class="ttdeci">__kernel void gemm_accumulate_biases_f32(__global uchar *accum_ptr, uint accum_stride_x, uint accum_step_x, uint accum_stride_y, uint accum_step_y, uint accum_offset_first_element_in_bytes, __global uchar *biases_ptr, uint biases_stride_x, uint biases_step_x, uint biases_offset_first_element_in_bytes)</div><div class="ttdoc">This kernel accumulates each row with the biases vector. </div><div class="ttdef"><b>Definition:</b> <a href="gemm_8cl_source.xhtml#l00262">gemm.cl:262</a></div></div>
<div class="ttc" id="gemm_8cl_xhtml_a675879eb72964ddbd5f71155da3b0cc3"><div class="ttname"><a href="gemm_8cl.xhtml#a675879eb72964ddbd5f71155da3b0cc3">gemm_transpose1x16_u8</a></div><div class="ttdeci">__kernel void gemm_transpose1x16_u8(__global uchar *src_ptr, uint src_stride_x, uint src_step_x, uint src_stride_y, uint src_step_y, uint src_offset_first_element_in_bytes, __global uchar *dst_ptr, uint dst_stride_x, uint dst_step_x, uint dst_stride_y, uint dst_step_y, uint dst_offset_first_element_in_bytes)</div><div class="ttdoc">This OpenCL kernel computes the &quot;vector&quot; 1x16 transposition of input matrix. </div><div class="ttdef"><b>Definition:</b> <a href="gemm_8cl_source.xhtml#l00105">gemm.cl:105</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.xhtml">src</a></li><li class="navelem"><a class="el" href="dir_aebb8dcc11953d78e620bbef0b9e2183.xhtml">core</a></li><li class="navelem"><a class="el" href="dir_8c278f79c760e5c5fbd911f9870614c1.xhtml">CL</a></li><li class="navelem"><a class="el" href="dir_25885286e9dad4fa105b7b25a8031bbf.xhtml">cl_kernels</a></li><li class="navelem"><a class="el" href="gemm_8cl.xhtml">gemm.cl</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:09 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
